!;-----------------------------------------------------------------------------
!;
!;          C Startup code for SH3 Monitor (HDI-M)
!;
!;
!; Initializes the Stack Pointer and then calls each of the initialization
!; functions in turn. When main() returns and all tidying up functions have
!; been called, the program sits in an infinite loop.
!;
!; Author  : Toyo Watarai
!; Date    : 17. Dec. 1996
!; Company : Hitachi Micro Systems Europe Ltd.
!; Version : 2.0
!;
!;-----------------------------------------------------------------------------

	.little

	.text
	.align 2

	.global __ENTRY
__ENTRY:
	MOV.L	init_sp, r15		! Initialise Stack Pointer
	MOV.L	init_sr, r1		! set SR value (Privileged mode, Bank=0, Block=0)
	LDC	r1, sr			! set SR
	MOV.L	init_vbr, r1		! set user VBR value
	LDC	r1, vbr			! set VBR

	MOV.L	main_addr, r2		! call main function
	JSR	@r2
	NOP

	.align	2
init_sp:
	.long	0x080F0000
init_sr:
	.long	0x400000E0
init_vbr:
	.long	0x08000000
main_addr:
	.long _main
