	.little

	.text
	.align 2

! This is the entry point for the interrupt handler. It needs to be
! moved to 0x600 bytes from the VBR.

	.global __INT_ENTRY
__INT_ENTRY:

	! Save the caller save registers
	MOV.L	r0, @-r15
	MOV.L	r1, @-r15
	MOV.L	r2, @-r15
	MOV.L	r3, @-r15

	! Save the parameter registers
	MOV.L	r4, @-r15

	! Set up the parameters	
	MOV.L	INTEVT_addr, r0		! get INTEVT address
	MOV.L	@r0, r4			! get interrupt event code

	!  Call the fn
	MOV.L	int_handler_addr, r0	! get interrupt handler addr
	JSR	@r0			!  call it
	NOP

	! Restore the parameter registers
	MOV.L	@r15+, r4

	! Restore the caller save registers
	MOV.L	@r15+, r3
	MOV.L	@r15+, r2
	MOV.L	@r15+, r1
	MOV.L	@r15+, r0

	! Return
	RTE
	NOP

	.align	2
INTEVT_addr:
	.long	0xffffffd8
int_handler_addr:
	.long	_int_handler

	.global __INT_ENTRY_FINISH
__INT_ENTRY_FINISH:

	.global	_get_vbr
_get_vbr:
	stc	vbr, r0
	rts
	nop
