/* Serial Communications Interface (SCI) */

typedef struct {
  unsigned char SCSMR;  /* Serial mode register */
  unsigned char pad0;
  unsigned char SCBRR;  /* Bit rate regiter */
  unsigned char pad1;
  unsigned char SCSCR;  /* Serial control regiter */
  unsigned char pad2;
  unsigned char SCTDR;  /* Transmit data register */
  unsigned char pad3;
  unsigned char SCSSR;  /* Serial status register */
  unsigned char pad4;
  unsigned char SCRDR;  /* Receive data register */
} sci_t;

/* Status register */
#define SCSSR_TDRE (1<<7)

/* Control register */
#define SCSCR_TIE (1<<7)
#define SCSCR_TE  (1<<5)
#define SCSCR_RE  (1<<4)

#define SCI_BASE_ADDR 0xfffffe80
